
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>ODATA WEB API扩展使用 / 憋错料</title>

    <meta name="description" content="ODATA WEB API扩展使用 一.概述 时间也算充足,抽点时间总结下OData的常用的使用方式,开放数据协议(OData)是一个查询和更新数据的Web协议.OData应用了web技术如HTTP.Atom发布协议(AtomPub)和JSON等来提供对不同应用程序,服务和存储的信息访问.除了提供一些基本的操作(像增删改查),也提供了一些高级的操作类似过滤数据和实体的导航.OData扩展了上述的协议但是不是取代他们.他可以被XML(ATOM)或者JSON取代但是OData的重要在于它符合REST原则.在某种意义上,它建立在'简单'">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">ODATA WEB API扩展使用</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>一、概述</p>
<p>时间也算充足，抽点时间总结下OData的常用的使用方式，<a href="http://www.odata.org/" rel="external nofollow noreferrer">开放数据协议</a><a href="http://www.odata.org/" rel="external nofollow noreferrer">(OData)</a>是一个查询和更新数据的Web协议。OData应用了web技术如HTTP、Atom发布协议(AtomPub)和JSON等来提供对不同应用程序，服务和存储的信息访问。除了提供一些基本的操作（像增删改查），也提供了一些高级的操作类似过滤数据和实体的导航。OData扩展了上述的协议但是不是取代他们。他可以被XML(ATOM)或者JSON取代但是OData的重要在于它符合REST原则。在某种意义上，它建立在‘简单‘的REST HTTP 服务上，并且有着清晰的目标&mdash;&mdash;简化和标准化我们操作和查询数据的方式。如果你过去在给你的REST服务创建搜索、过滤、或者分页API的时候感觉很麻烦，那么OData将是一个不错的选择。</p>
<p>二、WEB API使用：</p>
<p>　　1、通过NuGet获取&nbsp;Microsoft.AspNet.WebApi.OData 第三方插件DLL,Microsoft.AspNet.WebApi.OData提供可一系列的类扩展了Web API。</p>
<p>　　2、WebApiConfig进行下面代码添加，开启OData支持；</p>
<pre>using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Http;
using System.Net.Http.Formatting;
using System.Web.Http.OData.Extensions;

namespace MyMVCOData
{
    public static class WebApiConfig
    {
        public static void Register(HttpConfiguration config)
        {           // Web API 路由
            config.MapHttpAttributeRoutes();

            config.Routes.MapHttpRoute(
                name: "DefaultApi",
                routeTemplate: "api/{controller}/{id}",
                defaults: new { id = RouteParameter.Optional }
            );

            //启用Odata查询
            config.Formatters.JsonFormatter.AddQueryStringMapping("$format", "json", "application/json");
            config.Formatters.XmlFormatter.AddQueryStringMapping("$format", "xml", "application/xml");

            //config.EnableQuerySupport();
            config.AddODataQueryFilter();

            //config.SetTimeZoneInfo(TimeZoneInfo.Local);
        }
    }
}</pre>
<p>备注：</p>
<p>添加命名空间：using System.Net.Http.Formatting;</p>
<pre> config.Formatters.JsonFormatter.AddQueryStringMapping("$format", "json", "application/json");</pre>
<pre> config.Formatters.XmlFormatter.AddQueryStringMapping("$format", "xml", "application/xml");
</pre>
<p>功能说明：这段代码支持WebAPI数据接口显示可以以XML显示也可以以json格式显示，调用的时候如下：</p>
<p>http://localhost:port/api/ProjectManagent?$format=json 此处以json格式显示结果</p>
<p>http://localhost:port/api/ProjectManagent?$format=xml &nbsp;此处以xml格式显示结果</p>
<p>3、编写接口 API Control</p>
<p>添加Control 代码如下：</p>
<pre>using MyMVCOData.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using System.Web.Http.OData;
using System.Web.Http.OData.Query;

namespace MyMVCOData.Controllers
{
    public class MeetingsController : ApiController
    {
        private readonly IList&lt;Meeting&gt; _scheduledMeetings;

        public MeetingsController()
        {
            _scheduledMeetings = new List&lt;Meeting&gt;
            {
                new Meeting { Id = "1", Leader = "Mark Nichols", MeetingDate = new DateTime(2013, 1, 17), Title = "Project X Planning" },
                new Meeting { Id = "3", Leader = "Jim Phelps", MeetingDate = new DateTime(2013, 2, 8), Title = "Mission Discussion" },
                new Meeting { Id = "6", Leader = "Barney Collier", MeetingDate = new DateTime(2013, 3, 12), Title = "Advanced Device Technology" },
                new Meeting { Id = "7", Leader = "Willie Armitage", MeetingDate = new DateTime(2013, 5, 28), Title = "Maintaining a Strong Presence" },
                new Meeting { Id = "9", Leader = "Cinnamon Carter", MeetingDate = new DateTime(2013, 2, 15), Title = "Company Fashion" },
                new Meeting { Id = "10", Leader = "Rollin Hand", MeetingDate = new DateTime(2013, 1, 21), Title = "Magic Selling" }
            };
        }

        // GET api/Meeting
        //[EnableQuery(AllowedQueryOptions = AllowedQueryOptions.All)]
        //[Queryable(AllowedQueryOptions = AllowedQueryOptions.All)]
        //[EnableQuery(AllowedQueryOptions = AllowedQueryOptions.Top | AllowedQueryOptions.Skip)]
        //[EnableQuery(MaxTop = 100)] 配置调用限制项目
        [EnableQuery(AllowedQueryOptions = AllowedQueryOptions.All,MaxTop =100, MaxSkip = 200,PageSize =2,AllowedFunctions = AllowedFunctions.All)]
        public IQueryable&lt;Meeting&gt; Get()
        {
            return _scheduledMeetings.AsQueryable();
        }
    }
}</pre>
<p>4、接口调用说明：</p>
<p>下表列举了一些常用的Odata操作：</p>
<table>
<tbody>
<tr>
<td>
<br />操作</p>
</td>
<td>
<br />URL</p>
</td>
<td>
<br />说明</p>
</td>
</tr>
<tr>
<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; $filter</td>
<td>http://localhost:8090/api/Meetings?$filter=ProductName eq ‘Tofu‘</td>
<td>根据表达式的状态返回结果（返回ProductName 等于Tofu的Products）</td>
</tr>
<tr>
<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; $orderby</td>
<td>http://localhost:8090/api/Meetings?$orderby=ProductName</td>
<td>根据结果排序（根据ProductName列排序）</td>
</tr>
<tr>
<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; $skip</td>
<td>http://localhost:8090/api/Meetings?$skip=10</td>
<td>越过结果中的n条数据，常用于分页</td>
</tr>
<tr>
<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; $top</td>
<td>http://localhost:8090/api/Meetings?$top=10</td>
<td>返回结果中的前n条记录，常用于分页</td>
</tr>
<tr>
<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; $select</td>
<td>http://localhost:8090/api/Meetings?$filter=ProductName eq ‘Tofu‘&amp;$select=ProductName,UnitPrice</td>
<td>选择需要返回的属性</td>
</tr>
<tr>
<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; $expand</td>
<td>http://localhost:8090/api/Meetings?$expand=Supplier</td>
<td>返回Products中包含的导航属性（关联属性）Supplier</td>
</tr>
<tr>
<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; $inlinecount</td>
<td>http://localhost:8090/api/Meetings?$inlinecount=allpages</td>
<td>向服务器获取符合条件的资源总数（分页的total值）</td>
</tr>
</tbody>
</table>
<p>通过上面表格的内容，我们还可以通过组合查询条件来实现复杂的查询。</p>
<p><strong>常用查询举例：</strong></p>
<p>　　示例1：列出所有Product<br />　　URL:http://localhost:8914/Products</p>
<p>　　示例2,查询Products,只列出Name,Price例<br />　　URL：http://localhost:8914/Products?$select=Name,Price</p>
<p>　　示例3：列出Products(只有列Name,Price),包括Supplier<br />　　URL:http://localhost:8914/Products?$select=Name,Price&amp;$expand=Supplier</p>
<p>　　示例4:过滤Products,只显示分类为Test的数据<br />　　URL:http://localhost:8914/Products?$filter=Category eq &rsquo;Test&lsquo;</p>
<p>　　示例5:过滤Products,只显示分类为Test的数据,并排序<br />　　URL：http://localhost:8914/Products?$filter=Category eq &rsquo;Test&lsquo;&amp;$orderby=Price desc</p>
<p><strong>&nbsp; $filter的其它的使用方式：</strong></p>
<p>　　1.&nbsp; http://localhost/Products?$filter=Category eq ‘Test‘<br />　　　　过滤Category=Test<br />　　2.http://localhost/Products?$filter=Price lt 10<br />　　　　过滤Price小于10<br />　　3.http://localhost/Products?$filter=Price ge 5 and Price le 15<br />　　　　过滤5&lt;=Price&gt;=15<br />　　4.还可以使用数据库函数如：<br />　　　　$filter=substringof(‘zz‘,Name)<br />　　　　$filter=year(ReleaseDate) gt 2005</p>
<p>　　5.关于排序:<br />　　　　$orderby=Price<br />　　　　$orderby=Price desc<br />　　　　$orderby=Category,Price desc</p>
<p>　　6.还有一些过滤器如:<br />　　　　$skip，$top,$inlinecount等等</p>
<p>四、参考博客：</p>
<p>　　<a href="http://www.cnblogs.com/liuju150/p/4602715.html" rel="external nofollow noreferrer">http://www.cnblogs.com/liuju150/p/4602715.html</a></p>
<p><a href="http://www.cnblogs.com/shanyou/archive/2013/06/11/3131583.html" rel="external nofollow noreferrer">http://www.cnblogs.com/shanyou/archive/2013/06/11/3131583.html</a></p>
<p>五、后续问题：</p>
<p>　　针对查询结果时间的输出，目前输出的格式是：</p>
<pre>　　"MeetingDate": "2016-08-27T08:27:46.2664375+08:00"

　 如将日期的输出格式是我们自定义的如：2016-08-27 08:27:46</pre>
<p><a href="http://files.cnblogs.com/files/xibei666/MyMVCOData.rar" rel="external nofollow noreferrer">源码下载</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-17 15:44:05 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>ODATA WEB API扩展使用的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0j5lNEM.html" rel="bookmark">ODATA WEB API（二）----ODATA服务与客户端</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.概述 ODATA不经可以作为WebAPI建立相应的WEBAPI控制器,还可以建立ODataControl控制器,能够通过插件建立第三方ODataClinet类库:调用和使用数据变得简单可行. 二.建立OData Web API 服务端 1.通过NuGet添加第三方Microsoft.AspNet.OData: 2.建立相应的Model:Person和Trip using System; using System.Collections.Generic; using System.Compon			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBeOPK4.html" rel="bookmark">ASP&period;NET Web API 安全筛选器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:https://msdn.microsoft.com/zh-cn/magazine/dn781361.aspx 身份验证和授权是应用程序安全的基础.身份验证通过验证提供的凭据来确定用户身份,而授权则决定是否允许用户执行请求的操作.安全的 Web API 身份验证基于确定的身份请求和授权用户请求的资源访问. 您可以在 ASP.NET Web API 中使用 ASP.NET Web API 管道中提供的扩展点,以及使用由主机提供的选项来实现身份验证.对于 ASP.NET Web API 的第一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgZv5K4.html" rel="bookmark">Web Api系列教程第2季（OData篇）（二）&amp;mdash&semi;&amp;mdash&semi;使用Web Api创建只读的OData服务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 很久没更新了,之前有很多事情,所以拖了很久,非常抱歉.好了,废话不多说,下面开始正题.本篇仍然使用上一季的的项目背景(系列地址http://www.cnblogs.com/fzrain/p/3490137.html)来演示OData服务,因此我们可以直接使用之前建好的数据访问层.但是不是说一定要看到之前的所有内容,我们只是借用数据库访问层,对于数据库的模型构建移步(使用Entity Framework Code First构建数据库模型). 有了数据访问的基础,我们可以开始构建OData服			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBzL8AM.html" rel="bookmark">&lbrack;转&rsqb;使用ASP&period;NET Web API 2创建OData v4 终结点</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文转自:http://www.cnblogs.com/farb/p/ODataAspNetWebAPI.html 开放数据协议(Open Data Protocol[简称OData])是用于Web的数据访问协议.OData提供了一种对数据集进行CRUD操作(Create,Read,Update,Delete)的统一方式.Asp.Net Web API支持该协议的v3 和v4版,甚至可以创建一个和v3终结点并排运行的v4终结点.该博文演示了如何创建支持CRUD操作的OData v4终结点. 用到			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzX9qq3.html" rel="bookmark">&lbrack;转&rsqb;ASP&period;NET Web API对OData的支持</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://www.cnblogs.com/shanyou/archive/2013/06/11/3131583.html 在SOA的世界中,最重要的一个概念就是契约(contract).在云计算的世界中,有关通信的最重要的概念也是契约.XML具有强大对数据的描述能力,Atom格式和AtomPub都建立在XML之上,在Google和微软的推动下,也已经成为标准.但是,Atom/AtomPub和ODBC/OLEDB这样的真正数据交互协议相比较,还有着根本上的欠缺:缺乏数据类型的具体描述,降低了交			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lLkmP0.html" rel="bookmark">&lbrack;转&rsqb;Web Api系列教程第2季（OData篇）（二）&mdash;&mdash;使用Web Api创建只读的OData服务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文转自:http://www.cnblogs.com/fzrain/p/3923727.html 前言 很久没更新了,之前有很多事情,所以拖了很久,非常抱歉.好了,废话不多说,下面开始正题.本篇仍然使用上一季的的项目背景(系列地址http://www.cnblogs.com/fzrain/p/3490137.html)来演示OData服务,因此我们可以直接使用之前建好的数据访问层.但是不是说一定要看到之前的所有内容,我们只是借用数据库访问层,对于数据库的模型构建移步(使用Entity Fram			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QLpwo3.html" rel="bookmark">ASP&period;NET Web API对OData的支持</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				小分享:我有几张阿里云优惠券,用券购买或者升级阿里云相应产品最多可以优惠五折!领券地址:https://promotion.aliyun.com/ntms/act/ambassador/sharetouser.html?userCode=ohmepe03 在SOA的世界中,最重要的一个概念就是契约(contract).在云计算的世界中,有关通信的最重要的概念也是契约.XML具有强大对数据的描述能力,Atom格式和AtomPub都建立在XML之上,在Google和微软的推动下,也已经成为标准.但是			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPNWLm3.html" rel="bookmark">对一个前端AngularJS&comma;后端OData&comma;ASP&period;NET Web API案例的理解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				依然chsakell,他写了一篇前端AngularJS,后端OData,ASP.NET Web API的Demo,关于OData在ASP.NET Web API中的正删改查没有什么特别之处,但在前端调用API时,把各种调用使用$resouce封装在一个服务中的写法颇有借鉴意义. 文章:http://chsakell.com/2015/04/04/asp-net-web-api-feat-odata/源码:https://github.com/chsakell/odatawebapi 首先是领域模			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vE5BL0.html" rel="bookmark">ASP&period;NET Web API基于OData的增删改查，以及处理实体间关系</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本篇体验实现ASP.NET Web API基于OData的增删改查,以及处理实体间的关系. 首先是比较典型的一对多关系,Supplier和Product. public class Product { public int Id { get; set; } public string Name { get; set; } public decimal Price { get; set; } public string Category { get; set; } [ForeignKey(&quot;Sup			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n4Av7aM.html" rel="bookmark" class="title">深入理解memcached</a>
					<div>
						网上有5篇介绍memcached的文章,写的挺好,这里转过来. memcached完全剖析–1. memcached的基础 memcached全面剖析–2.理解memcached的内存存储 memca ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/k0elPJM.html" rel="bookmark" class="title">关于Linux下clrsrc函数的实现</a>
					<div>
						在windows下,c语言有库conio.h,实现了不少函数,但是Linux c没有这个库,内部的函数需要自己实现. //clrsrc清屏函数的一种实现:void clrscr(void) { sys ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0a7Olq4.html" rel="bookmark" class="title">w3wp占用CPU过高</a>
					<div>
						w3wp占用CPU过高 在此之前项目有发生过两次类似的状况,都得以解决,但最近又会发现偶尔CPU会跑满,虽然之前使用过WinDbg解决过两次问题但人的记忆是不可靠的,今天处理同样问题的时候还是遇到了一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lr7vb4.html" rel="bookmark" class="title">&period;net core nlog记录日志</a>
					<div>
						1.通过nuget 查找 下载 NLog.Extensions.Logging 2.配置nlog.config文件 1 &lt;?xml version=&quot;1.0&quot; encodin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0d59aZ3.html" rel="bookmark" class="title">Swift 全功能的绘图板开发</a>
					<div>
						转载请注明出处:http://blog.csdn.net/zhangao0086/article/details/43836789. 要做一个全功能的绘图板,至少要支持以下这些功能: 支持铅笔绘图(画 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoGB2xM.html" rel="bookmark" class="title">Python 第八章笔记</a>
					<div>
						第八章总结 8.5. heapq - 堆队列算法 有8个算法 方法 heappush heappop heappushpop heapreplace heapify merge nlargest ns ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MV8gR13.html" rel="bookmark" class="title">hibernate xxx is not mapped 错误原因及解决方法</a>
					<div>
						错误: &quot;hibernate xxx is not mapped&quot; 原因: xxx.hbm.xml文件没有发布到target相应目录中. 解决方法: pom.xml中,节点内添加如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bgRVo3.html" rel="bookmark" class="title">有耗介质中波的传播</a>
					<div>
											</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmOaNn3.html" rel="bookmark" class="title">&lpar;8&sol;18&rpar;重学Standford&lowbar;iOS7开发&lowbar;协议、block、动画&lowbar;课程笔记</a>
					<div>
						第八课: 1.协议 另一种安全处理id类型的方式如:id &lt;MyProtocol&gt; obj a.声明 //协议一般放于.h文件中或者在类的.h文件中 @protocol Foo &lt;X ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38w7PR0.html" rel="bookmark" class="title">C&plus;&plus;面试题（三）</a>
					<div>
						1 什么是函数对象?有什么作用? 2 STL迭代器种类? 五类迭代器如下:       (1)输入迭代器:只读,一次传递       为输入迭代器预定义实现只有istream_iterator和ist ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDvgy73.html" rel="bookmark" class="title">Cordova6&period;x自定义插件之Andorid</a>
					<div>
						1.继承了CordovaPlugin的Java Class 需要重写execute方法,如下: 2.在res/xml/config.xml中关联上述java class 3.在assets/www/p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDrLwY3.html" rel="bookmark" class="title">添加外置的NFS存储</a>
					<div>
						NFS是Network File System 的简称,即网络文件系统,也是最常见的网络共享机制,是在UNIX系统间实现磁盘文件共享的一种方法.它支持应用程序在客户端通过网络存取位于服务器磁盘中数据的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmYRqXM.html" rel="bookmark" class="title">linux memcached开机启动</a>
					<div>
						1.首先是写 service脚本 service脚本需要进入到目录/etc/init.d中,然后touch memcached,最后vim memcached后进行脚本编写,脚本如下: #!/bin/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MERx5D0.html" rel="bookmark" class="title">记录每个用户的操作记录</a>
					<div>
						linux系统环境下,不管是root用户还是其他的用户只有登录系统后的操作都可以通过命令history查看历史记录. 假如一台服务器有多人登录,一天因为某人误删了重要的数据 这时通过history是没 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vjEdR3.html" rel="bookmark" class="title">移动开发：Native、Hybrid与HTML5</a>
					<div>
						WEB APP.HYBRID APP与NATIVE APP的设计差异:http://www.uisdc.com/web-hybrid-native-app 移动应用开发指南:Native.Hybrid ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AEXZD4.html" rel="bookmark" class="title">如鹏网学习笔记（四）&period;Net常用类库</a>
					<div>
						.Net常用类库 一.String成员方法(常用) 1,bool Contains(string str) 判断字符串对象是否包含给定的内容 2,bool StartsWith(String str) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KvgJ9M.html" rel="bookmark" class="title">分库分表数据库中间件对比</a>
					<div>
						(一)关键问题 1.读写分离 2.分库分表 3.类别 lib库 1)业务直接到数据库,少一层proxy效率更高 2)没有proxy的lvs的单点问题 proxy 1)统一管理所有到数据库的连接,连接复 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyBjlL0.html" rel="bookmark" class="title">冒泡算法-bubble</a>
					<div>
						冒泡算法在数据只有几个无序时是最快的算法,但是如果全部无序的话就变成了最慢的算法了,时间复杂度为O(n^2) public class bubbleSort { public static void  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OyDwPM.html" rel="bookmark" class="title">查询Oracle正在执行和执行过的SQL语句</a>
					<div>
						---正在执行的 select a.username, a.sid,b.SQL_TEXT, b.SQL_FULLTEXT   from v$session a, v$sqlarea b where a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmNpgQ0.html" rel="bookmark" class="title">apache AH00558错误： Could not reliably determine the server&amp;&num;39&semi;s fully qualified domain name</a>
					<div>
						/usr/local/httpd/bin/apachectl start AH00558: httpd: Could not reliably determine the server's fully ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
